/* assubr.c */

/*
 * (C) Copyright 1989,1990
 * All Rights Reserved
 *
 * Alan R. Baldwin
 * 721 Berkeley St.
 * Kent, Ohio  44240
 */

#include <stdio.h>
#include <setjmp.h>
#include <string.h>
#include <alloca.h>
#include "asm.h"

extern int IsAnError;  /* Ver 1.56 GB */

/*
 * Note an error.
 * If the error is already in the
 * error buffer don't note it again.
 * If the error is serious enough to
 * stop the parse (a `q' error) just
 * give up.
 */
VOID
err(c)
     register c;
{
  register char *p;
  
  p = eb;
  while (p < ep)
    if (*p++ == c)
      return;
  if (p < &eb[NERR]) {
    *p++ = c;
    ep = p;
  }
  if (c == 'q')
    longjmp(jump_env, -1);
}

/*
 * Send errors to the standard output.
 */
VOID
diag()
{
  register char *p;
  int errflag=0;       /* Indicates that the word error has been printed */
  int i;
  
  if (eb != ep) {
    p = eb;
    while(p < ep)
      {
	
	/* MY VIDEO ERROR PATCH - GB */
	if(!errflag)
	  {
	    fprintf(stdout, "** ERROR! **");
	    fprintf(stdout, "    LINE #: %d", line); /* ver 1.55 */
	    fprintf(stdout, "\tTYPE: %c = ", *p);
	    errflag = 1;
	  }
	else
	  fprintf(stdout, "\t\t\t\tTYPE: %c = ", *p);  /* ver 1.55 */
	
	switch(*p)                                       /* ver 1.56 */
	  {
	  case '.': fprintf(stdout, "%s", "Location counter syntax\n");
	    break;
	  case 'a': fprintf(stdout, "%s", "Addressing mode error\n");
	    break;
	  case 'b': fprintf(stdout, "%s", "Direct Page boundary error\n");
	    break;
	  case 'd': fprintf(stdout, "%s", "Direct Page addressing error\n");
	    break;
	  case 'i': fprintf(stdout, "%s", "Include file or .if/.endif error\n");
	    break;
	  case 'm': fprintf(stdout, "%s", "Awfully fond of this label???\n");
	    break;
	  case 'o': fprintf(stdout, "%s", "Directive, Mnemonic or .org error\n");
	    break;
	  case 'p': fprintf(stdout, "%s", "Phase error\n");
	    break;
	  case 'q': fprintf(stdout, "%s", "Syntax Error\n");
	    break;
	  case 'r': fprintf(stdout, "%s", "Relocation error\n");
	    break;
	  case 'u': fprintf(stdout, "%s", "Undefined symbol encountered\n");
	    break;
	  }
	
	p++;
	IsAnError = 1;   /* Set global error flag true - ver 1.56 GB */
      }
    
    
    
  }
}

/*
 * Note an 'r' error.
 */
VOID
rerr()
{
  err('r');
}

/*
 * Note an 'a' error.
 */
VOID
aerr()
{
  err('a');
}

/*
 * Note a 'q' error.
 */
VOID
qerr()
{
  err('q');
}



















